<?php
class ModelCatalogGuide extends Model {
	public function addGuide($data) {
		$this->db->query("INSERT INTO " . DB_PREFIX . "guide SET sort_order = '" . (int)$this->request->post['sort_order'] . "', status = '" . (int)$data['status'] . "'");

		$guide_id = $this->db->getLastId(); 
			
		foreach ($data['guide_description'] as $language_id => $value) {
			$this->db->query("INSERT INTO " . DB_PREFIX . "guide_description SET guide_id = '" . (int)$guide_id . "', language_id = '" . (int)$language_id . "', title = '" . $this->db->escape($value['title']) . "', description = '" . $this->db->escape($value['description']) . "'");
		}
		
		if (isset($data['guide_store'])) {
			foreach ($data['guide_store'] as $store_id) {
				$this->db->query("INSERT INTO " . DB_PREFIX . "guide_to_store SET guide_id = '" . (int)$guide_id . "', store_id = '" . (int)$store_id . "'");
			}
		}
		
		if ($data['keyword']) {
			$this->db->query("INSERT INTO " . DB_PREFIX . "url_alias SET query = 'guide_id=" . (int)$guide_id . "', keyword = '" . $this->db->escape($data['keyword']) . "'");
		}
		
		$this->cache->delete('guide');
	}
	
	public function editGuide($guide_id, $data) {
		$this->db->query("UPDATE " . DB_PREFIX . "guide SET sort_order = '" . (int)$data['sort_order'] . "', status = '" . (int)$data['status'] . "' WHERE guide_id = '" . (int)$guide_id . "'");

		$this->db->query("DELETE FROM " . DB_PREFIX . "guide_description WHERE guide_id = '" . (int)$guide_id . "'");
					
		foreach ($data['guide_description'] as $language_id => $value) {
			$this->db->query("INSERT INTO " . DB_PREFIX . "guide_description SET guide_id = '" . (int)$guide_id . "', language_id = '" . (int)$language_id . "', title = '" . $this->db->escape($value['title']) . "', description = '" . $this->db->escape($value['description']) . "'");
		}

		$this->db->query("DELETE FROM " . DB_PREFIX . "guide_to_store WHERE guide_id = '" . (int)$guide_id . "'");
		
		if (isset($data['guide_store'])) {
			foreach ($data['guide_store'] as $store_id) {
				$this->db->query("INSERT INTO " . DB_PREFIX . "guide_to_store SET guide_id = '" . (int)$guide_id . "', store_id = '" . (int)$store_id . "'");
			}
		}
		
		$this->db->query("DELETE FROM " . DB_PREFIX . "url_alias WHERE query = 'guide_id=" . (int)$guide_id. "'");
		
		if ($data['keyword']) {
			$this->db->query("INSERT INTO " . DB_PREFIX . "url_alias SET query = 'guide_id=" . (int)$guide_id . "', keyword = '" . $this->db->escape($data['keyword']) . "'");
		}
		
		$this->cache->delete('guide');
	}
	
	public function deleteGuide($guide_id) {
		$this->db->query("DELETE FROM " . DB_PREFIX . "guide WHERE guide_id = '" . (int)$guide_id . "'");
		$this->db->query("DELETE FROM " . DB_PREFIX . "guide_description WHERE guide_id = '" . (int)$guide_id . "'");
		$this->db->query("DELETE FROM " . DB_PREFIX . "guide_to_store WHERE guide_id = '" . (int)$guide_id . "'");
		$this->db->query("DELETE FROM " . DB_PREFIX . "url_alias WHERE query = 'guide_id=" . (int)$guide_id . "'");

		$this->cache->delete('guide');
	}	

	public function getGuide($guide_id) {
		$query = $this->db->query("SELECT DISTINCT *, (SELECT keyword FROM " . DB_PREFIX . "url_alias WHERE query = 'guide_id=" . (int)$guide_id . "') AS keyword FROM " . DB_PREFIX . "guide WHERE guide_id = '" . (int)$guide_id . "'");
		
		return $query->row;
	}
		
	public function getGuides($data = array()) {
		if ($data) {
			$sql = "SELECT * FROM " . DB_PREFIX . "guide i LEFT JOIN " . DB_PREFIX . "guide_description id ON (i.guide_id = id.guide_id) WHERE id.language_id = '" . (int)$this->config->get('config_language_id') . "'";
		
			$sort_data = array(
				'id.title',
				'i.sort_order'
			);		
		
			if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
				$sql .= " ORDER BY " . $data['sort'];	
			} else {
				$sql .= " ORDER BY id.title";	
			}
			
			if (isset($data['order']) && ($data['order'] == 'DESC')) {
				$sql .= " DESC";
			} else {
				$sql .= " ASC";
			}
		
			if (isset($data['start']) || isset($data['limit'])) {
				if ($data['start'] < 0) {
					$data['start'] = 0;
				}		

				if ($data['limit'] < 1) {
					$data['limit'] = 20;
				}	
			
				$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
			}	
			
			$query = $this->db->query($sql);
			
			return $query->rows;
		} else {
			$guide_data = $this->cache->get('guide.' . $this->config->get('config_language_id'));
		
			if (!$guide_data) {
				$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "guide i LEFT JOIN " . DB_PREFIX . "guide_description id ON (i.guide_id = id.guide_id) WHERE id.language_id = '" . (int)$this->config->get('config_language_id') . "' ORDER BY id.title");
	
				$guide_data = $query->rows;
			
				$this->cache->set('guide.' . $this->config->get('config_language_id'), $guide_data);
			}	
	
			return $guide_data;			
		}
	}
	
	public function getGuideDescriptions($guide_id) {
		$guide_description_data = array();
		
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "guide_description WHERE guide_id = '" . (int)$guide_id . "'");

		foreach ($query->rows as $result) {
			$guide_description_data[$result['language_id']] = array(
				'title'       => $result['title'],
				'description' => $result['description']
			);
		}
		
		return $guide_description_data;
	}
	
	public function getGuideStores($guide_id) {
		$guide_store_data = array();
		
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "guide_to_store WHERE guide_id = '" . (int)$guide_id . "'");

		foreach ($query->rows as $result) {
			$guide_store_data[] = $result['store_id'];
		}
		
		return $guide_store_data;
	}
	
	public function getTotalGuides() {
      	$query = $this->db->query("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "guide");
		
		return $query->row['total'];
	}	
}
?>